#![feature(inline_const)]
#![feature(inline_const_pat)]
#![feature(wasm_abi)]
#![cfg_attr(not(test), no_std)]
#![allow(incomplete_features)]

extern crate alloc;

use alloc::boxed::Box;
use pkmn_lib_interface::set_load_script_fn;

#[macro_use]

pub mod registered_scripts;
pub mod moves;
pub mod pokemon;
pub mod util_scripts;
pub(crate) mod utils;
pub mod weather;

#[no_mangle]
#[cfg(not(test))]
extern "wasm" fn _init() {
    set_load_script_fn(Box::new(registered_scripts::get_script));
}
