use crate::app_interface::Pokemon;
use crate::{ExternRef, ExternalReferenceType};

#[derive(Clone)]
pub struct Party {
    reference: ExternRef<Party>,
}

impl Party {
    pub fn new(reference: ExternRef<Party>) -> Self {
        Self { reference }
    }

    #[cfg(not(feature = "mock_data"))]
    pub fn get_pokemon(&self, index: usize) -> Option<Pokemon> {
        unsafe { party_get_pokemon(self.reference, index).get_value() }
    }

    pub fn length(&self) -> usize {
        unsafe { party_get_length(self.reference) }
    }
}

impl ExternalReferenceType for Party {
    fn from_extern_value(reference: ExternRef<Self>) -> Self {
        Self::new(reference)
    }
}

#[cfg(not(feature = "mock_data"))]
extern "wasm" {
    fn party_get_pokemon(r: ExternRef<Party>, index: usize) -> ExternRef<Pokemon>;
    fn party_get_length(r: ExternRef<Party>) -> usize;
}
